# $Id: build.make,v 6.20 2002/06/15 22:22:15 cher Exp $

# Copyright (C) 1995-2002 Alexander Chernov <cher@ispras.ru>
# Created: <95/11/02 14:29:26 cher>

# This library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Lesser General Public
# License as published by the Free Software Foundation; either
# version 2 of the License, or (at your option) any later version.
#
# This library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Lesser General Public License for more details.

include files.make
include $(L_PRJ_HOME)/etc/Main.make
include version.sh

SHARED_SONAME=${DLLPFX}reuse${DLLSFX}.${REUSE_VERSION}
SHARED_NAME=${DLLPFX}reuse${DLLSFX}

libreuse=$(OBJDIR)/${LIBPFX}reuse${LIBSFX}
dllreuse=$(OBJDIR)/${SHARED_SONAME}
dllalias=$(OBJDIR)/${SHARED_NAME}

CLOCAL=-D__REUSE__

vernum=${DEPDIR}/version_number
verbase=${DEPDIR}/reuse_version

mddiropt=${CONF_MAKEDEPS_GENOPT} ${CONF_MAKEDEPS_DEPOPT}

local_default: all
all: compile

compile: ${libreuse} compile_dll_${CONF_DLL}
compile_dll_0: 
compile_dll_1: ${dllreuse}
compile_dll_2: ${OBJDIR}/${LIBPFX}reuse_s${LIBSFX} ${OBJDIR}/reuse.dll

install: compile install_only
install_lib: compile install_only_lib
install_only: install_only_dll_$(CONF_DLL)
	$(INSTALL) -m $(LIB_MODE) $(INST_LIB) ${libreuse}
	-rm $(INST_INCL)/reuse/*
	$(INSTALL) -m $(LIB_MODE) $(INST_INCL)/reuse $(HFILES)
install_only_lib: install_only_dll_${CONF_DLL}
	$(INSTALL) -m $(LIB_MODE) $(INST_LIB) ${libreuse}

install_only_dll_0:
install_only_dll_1:
	$(INSTALL) -m $(EXE_MODE) $(INST_LIBEXEC) ${dllreuse}
#	ln -sf ${SHARED_SONAME} $(INST_LIBEXEC)/${SHARED_NAME}
	$(INSTALL) -m $(EXE_MODE) $(INST_LIB) ${dllreuse}
	ln -f ${INST_LIBEXEC}/${SHARED_SONAME} ${INST_LIB}
	ln -sf ${SHARED_SONAME} ${INST_LIB}/${SHARED_NAME}
install_only_dll_2:
#	$(INSTALL) -m $(EXE_MODE) $(INST_LIB) ${OBJDIR}/reuse.dll
	$(INSTALL) -m $(EXE_MODE) $(INST_LIB) $(OBJDIR)/${LIBPFX}reuse_s${LIBSFX}
	$(INSTALL) -m $(EXE_MODE) $(INST_LIBEXEC) $(OBJDIR)/reuse.dll

deps: $(CFILES) $(HFILES) deps_static deps_dll_${CONF_DLL}
deps_static:
	$(DEPREM) true > $(DEPDIR)/deps.make
	$(DEPREM) $(MAKEDEPS) ${mddiropt} -s ${OBJSFX} -g -o "${OBJ_OUTPUT_FLAG}" -c '$$(CC) $$(CALLFLAGS) -DSTATIC' -d $(OBJDIR)/ $(CFILES) >> $(DEPDIR)/deps.make
deps_dll_0:
deps_dll_1:
	$(DEPREM) $(MAKEDEPS) ${mddiropt} -s ${OBJSFX} -g -o "${OBJ_OUTPUT_FLAG}" -c '$$(CC) $$(CALLFLAGS) $$(CDLLFLAGS)' -d $(PICDIR)/ -v DLLOBJECTS $(CFILES) >> $(DEPDIR)/deps.make
deps_dll_2:
	$(DEPREM) $(MAKEDEPS) ${mddiropt} -s ${OBJSFX} -g -o "${OBJ_OUTPUT_FLAG}" -c '$$(CC) $$(CALLFLAGS) $$(CDLLFLAGS) -DDYNAMIC' -d $(PICDIR)/ -v DLLOBJECTS $(CFILES) >> $(DEPDIR)/deps.make

include $(DEPDIR)/deps.make

ifeq (${CONF_DLL}, 2)
${OBJDIR}/reuse.dll $(libreuse): ${DLLOBJECTS}
	$(CLD) $(LDALLFLAGS) -Wl,--out-implib,${OBJDIR}/${LIBPFX}reuse${LIBSFX} -shared -o ${OBJDIR}/reuse.dll $^
$(OBJDIR)/${LIBPFX}reuse_s${LIBSFX} : $(OBJECTS)
	$(AR) ${ARFLAGS} $(OBJDIR)/${LIBPFX}reuse_s${LIBSFX} $^
else
$(libreuse) : $(OBJECTS)
	$(AR) ${ARFLAGS} $(libreuse) $(OBJECTS)
endif

$(dllreuse) : $(DLLOBJECTS)
	$(CLD) $(LDALLFLAGS) $(LDDLLFLAGS) $^ -o $@
$(dllalias) : $(dllreuse)
	ln -s $(SHARED_SONAME) $(dllalias)

${vernum} : $(SRCFILES)
	${DEPREM} AWK=${AWK} ${MAKEBNUM} -N $@ $(SRCFILES)
${verbase}.c ${verbase}.h: version.sh ${vernum}
	${DEPREM} AWK=${AWK} ./mkver.sh ${verbase} ${vernum}

log:
	cvs log -l | ../tools/o/mkChangeLog etc/authors ChangeLog ChangeLog
	cd reuse; cvs log -l | ../../tools/o/mkChangeLog ../etc/authors ChangeLog ChangeLog
	cd reuse/unix; cvs log -l | ../../../tools/o/mkChangeLog ../../etc/authors ChangeLog ChangeLog
	cd reuse/win32; cvs log -l | ../../../tools/o/mkChangeLog ../../etc/authors ChangeLog ChangeLog
	cd reuse/dos; cvs log -l | ../../../tools/o/mkChangeLog ../../etc/authors ChangeLog ChangeLog

