/* $Id: FlexString.c,v 6.12 2002/06/08 08:36:42 cher Exp $ */

/* Copyright (C) 1995-2002 Alexander Chernov <cher@ispras.ru> */
/* Created: <95/11/01 17:30:28 cher> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

static char const rcsid[]=
"$Id: FlexString.c,v 6.12 2002/06/08 08:36:42 cher Exp $";

#include "lconfig.h"
#include <p_config.h>
#include <p_integral.h>

#include CONF_DEPFILE("reuse_version.h")

#include "reuse/ReuseDefs.h"
#include "reuse/xalloc.h"
#include "reuse/FlexString.h"

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <limits.h>

/* memory management macros */

#define CLUSTER           32
#define ALIGN(size)       ((size+31) & 0xffffffe0)

#ifdef REUSE_DEBUG

#define CHECK(ptr)        assert((ptr) != NULL)
#define CHECKPFS(pfs)     assert((pfs)->Used == 0 || (pfs)->Used < (pfs)->Allocd)

#else

#define CHECK(p)
#define CHECKPFS(p)

#endif /* REUSE_DEBUG */

void
reuse_fs_range_error(char *func)
{
  fprintf(stderr, "Range error in function %s\n", func);
  abort();
}

/**
 * Local variables:
 *  compile-command: "make -C .."
 *  tags-file-name: "../TAGS"
 *  c-font-lock-extra-types: ("FILE" "\\sw+_t" "Bool" "tFString")
 * End:
 */
