/* $Id: General.c,v 6.8 2002/02/20 21:44:09 cher Exp $ */

/* Copyright (C) 1995-2002 Alexander Chernov <cher@ispras.ru> */
/* Ich, Doktor Josef Grosch, Informatiker, Sept. 1987 */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

static char const rcsid [] =
"$Id: General.c,v 6.8 2002/02/20 21:44:09 cher Exp $";

#include "lconfig.h"
#include <p_config.h>

#include CONF_DEPFILE("reuse_version.h")

# include "reuse/Defs.h"
# include "reuse/General.h"

/* Returns the logarithm to the base 2 of 'x'.  */
Cardinal
Log2(unsigned long x)
{
  register Cardinal y = 0;

  if (x >= 65536) { y += 16; x >>= 16; }
  if (x >=   256) { y +=  8; x >>=  8; }
  if (x >=    16) { y +=  4; x >>=  4; }
  if (x >=     4) { y +=  2; x >>=  2; }
  if (x >=     2) { y +=  1; x >>=  1; }
  return y;
}

/* Returns 2 to the power of 'x'.               */
unsigned long
Exp2(Cardinal x)
{
  register long y = 1;
  
  if (x >= 16) { x -= 16; y <<= 16; }
  if (x >=  8) { x -=  8; y <<=  8; }
  if (x >=  4) { x -=  4; y <<=  4; }
  if (x >=  2) { x -=  2; y <<=  2; }
  if (x >=  1) { x -=  1; y <<=  1; }
  return y;
}

static struct { char yychar; double yydouble; } yyForAlign;
unsigned short   yyMaxAlign      = sizeof (yyForAlign) - sizeof (double);
long    yyAlignMasks [] = { 0,
   0xffffffff, 0xfffffffe, 0xffffffff, 0xfffffffc,
   0xffffffff, 0xffffffff, 0xffffffff, 0xfffffff8 };

  unsigned short
ReuseGetMaxAlign(void)
{
  return yyMaxAlign;
}

  long*
ReuseGetAlignMasks(void)
{
  return yyAlignMasks;
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("\\sw+_t" "FILE" "Cardinal")
 * End:
 */
