/* -*- mode:c -*- */
/* $Id: fsint.c,v 1.1 2002/05/19 11:18:17 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>

#include "reuse/FlexString.h"
#include "reuse/ReuseDefs.h"

#include <stdlib.h>
#include <errno.h>
#include <limits.h>
#include <assert.h>

#define CLUSTER           32
#define ALIGN(size)       ((size+31) & 0xffffffe0)

#ifdef REUSE_DEBUG
#  define CHECK(ptr)        assert((ptr) != NULL)
#  define CHECKPFS(pfs)     assert((pfs)->Used == 0 || (pfs)->Used < (pfs)->Allocd)
#else
#  define CHECK(p)
#  define CHECKPFS(p)
#endif /* REUSE_DEBUG */

int
_fsInt(tFString *fs,int *pi)
{
  char *ptr2;
  long temp;

  CHECKPFS(fs);
  
  temp = strtol(fs->String,&ptr2,10);
  if(*ptr2 != '\0')
    return 0;
  if(fs->String == ptr2)
    return 0;
  if((temp == LONG_MAX || temp == LONG_MIN) && errno == ERANGE)
    return 0;
  if(temp < INT_MIN || temp > INT_MAX)
    return 0;
  *pi = temp;
  return 1;
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("FILE" "\\sw+_t" "tFString")
 * End:
 */
