/* -*- mode:c -*- */
/* $Id: fsread.c,v 1.1 2002/05/19 11:18:17 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>

#include "reuse/FlexString.h"
#include "reuse/ReuseDefs.h"

#include <assert.h>
#include <ctype.h>

#define CLUSTER           32
#define ALIGN(size)       ((size+31) & 0xffffffe0)

#ifdef REUSE_DEBUG
#  define CHECK(ptr)        assert((ptr) != NULL)
#  define CHECKPFS(pfs)     assert((pfs)->Used == 0 || (pfs)->Used < (pfs)->Allocd)
#else
#  define CHECK(p)
#  define CHECKPFS(p)
#endif /* REUSE_DEBUG */

void
_fsRead(tFString *pfs,FILE *f)
{
  int iCh;
  
  CHECKPFS(pfs);
  CHECK(f);
  
  fsClear(*pfs);
  for(iCh = getc(f); iCh != EOF && isspace(iCh); iCh = getc(f))
    /* EMPTY */;
  
  assert(iCh == '\'');
  
  iCh = getc(f);
  while(1)
    {
      if(iCh == '\'')
        {
          iCh = getc(f);
          if(iCh != '\'')
            break;
        }
      
      fsAdd(*pfs,(char) iCh);
      iCh = getc(f);
    }
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("FILE" "\\sw+_t" "tFString")
 * End:
 */
