/* -*- mode:c -*- */
/* $Id: ident_close.c,v 1.1 2002/05/19 11:19:01 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>

#include "reuse/hashP.h"
#include "reuse/xalloc.h"

extern hashstate_t ident_state;

/**
 * NAME:    ident_close
 * PURPOSE: finalize the module
 */
void
ident_close(void)
{
  int i;

  if (!ident_state.initialized) ident_init();

  for (i = 0; i < ident_state.table_size; i++)
    {
      if (ident_state.table[i].hash != 0)
        {
          xfree(ident_state.table[i].string);
        }
    }
  xfree(ident_state.table);
  xfree(ident_state.map);
  ident_state.table = NULL;
  ident_state.map = NULL;
  ident_state.table_size = 0;
  ident_state.total_idents = 0;
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 * End:
 */
