/* -*- mode:c -*- */
/* $Id: ident_dump_table.c,v 1.1 2002/05/19 11:19:01 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>

#include "reuse/hashP.h"

extern hashstate_t ident_state;

/**
 * NAME:    ident_dump_table
 * PURPOSE: print the whole identifier table
 * ARGS:    out - FILE to print the table to
 */
void
ident_dump_table(FILE *out)
{
  int i;

  if (!ident_state.initialized) ident_init();

  fprintf(out, "Identifier table\n");
  fprintf(out, "================\n");
  fprintf(out, "Num\tMap\tIndex\tHash\t\tLen\tString\n");
  for (i = 0; i < ident_state.total_idents; i++)
    {
      fprintf(out, "%d\t%d\t%d\t%08x\t%d\t%s\n",
              i,
              ident_state.map[i],
              ident_state.table[ident_state.map[i]].hash % ident_state.table_size,
              ident_state.table[ident_state.map[i]].hash,
              ident_state.table[ident_state.map[i]].len,
              ident_state.table[ident_state.map[i]].string);
    }
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 * End:
 */
