/* -*- mode:c -*- */
/* $Id: ident_dup.c,v 1.1 2002/05/19 11:19:01 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>

#include "reuse/hashP.h"
#include "reuse/xalloc.h"

#include <assert.h>

extern hashstate_t ident_state;

/**
 * NAME:    ident_dup
 * PURPOSE: get a copy of the string corresponding to the given identifier
 * ARGS:    id - identifier number
 * RETURN:  copy of the string allocated in the heap
 */
char *
ident_dup(ident_t id)
{
  if (!ident_state.initialized) ident_init();

  assert(/*id >= 0 && */id < (ident_t) ident_state.total_idents);
  return xstrdup(ident_state.table[ident_state.map[id]].string);
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 * End:
 */
