/* -*- mode:c -*- */
/* $Id: ident_reinit.c,v 1.1 2002/05/19 11:19:01 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>

#include "reuse/hashP.h"
#include "reuse/xalloc.h"

extern hashstate_t ident_state;

/**
 * NAME:    ident_reinit
 * PURPOSE: reset the existing hash table
 */
void
ident_reinit(void)
{
  int i;

  if (!ident_state.initialized) ident_init();

  ident_state.total_idents = 1;
  for (i = 1; i < ident_state.table_size; i++)
    {
      if (ident_state.table[i].hash != 0)
        {
          ident_state.table[i].hash = 0;
          ident_state.table[i].ident = 0;
          xfree(ident_state.table[i].string);
          ident_state.table[i].string = NULL;
          ident_state.table[i].len = 0;
        }
    }
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 * End:
 */
