/* -*- mode:c -*- */
/* $Id: ident_statistics.c,v 1.1 2002/05/19 11:19:01 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>

#include "reuse/hashP.h"

extern hashstate_t ident_state;

/**
 * NAME:    ident_statistics
 * PURPOSE: print usage statistics
 * ARGS:    out - FILE to print statistics to
 */
void
ident_statistics(FILE *out)
{
  if (!ident_state.initialized) ident_init();

  fprintf(out, "Identifier table statistics:\n");
  fprintf(out, "============================\n");
  fprintf(out, "Table size:              %d\n", ident_state.table_size);
  fprintf(out, "Number of identifiers:   %d\n", ident_state.total_idents);
  fprintf(out, "Capacity percentage:     %f%%\n",
          ((double) ident_state.total_idents / (double) ident_state.table_size)*100);
  fprintf(out, "Number of rehashings:    %d\n", ident_state.stat_rehash_num);
  fprintf(out, "Number of lookups:       %d\n", ident_state.stat_lookups_num);
  fprintf(out, "Number of successes:     %d\n", ident_state.stat_success_num);
  fprintf(out, "Number of search cycles: %d\n", ident_state.stat_cycles_num);
  fprintf(out, "Average search length:   %f\n",
          (double) ident_state.stat_cycles_num / (double) ident_state.stat_lookups_num);
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 * End:
 */
