/* $Id: HeapMem.h,v 6.4 2001/06/23 07:03:05 cher Exp $ */

/* Copyright (C) 1995-2001 Alexander Chernov <cher@ispras.ru> */
/* Created: <95/12/03 15:30:32 cher> */

/*
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#ifndef __HeapMem_h__
#define __HeapMem_h__

#include <reuse/Defs.h>

#include <stdlib.h>

/* void chInitModule (void); */
/* The function initializes internal data structures of the module. */

/* void chStatistics (FILE *); */
/* Prints statistics about memory usage. Verbosity of this statistics
 * depends on preprocessor switches that were used for compiling
 * the module
 */

/* void chCloseModule (void); */
/* Release memory allocated for internal data and performs other
 * closing operations
 */

#if defined __cplusplus
extern "C" {
#endif /* __cplusplus */

  void * _checked_malloc  (size_t);
  void * _checked_calloc  (size_t, size_t);
  void   _checked_free    (void *);
  void * _checked_realloc (void *, size_t);
  void * _checked_expand  (void *, size_t);
  void * _checked_shrink  (void *, size_t);
  char * _checked_strdup  (char *);

  void *_NULL_checked_malloc  (size_t);
  void *_NULL_checked_calloc  (size_t nitems, size_t size);
  void *_NULL_checked_realloc (void *, size_t);
  char *_NULL_checked_strdup  (char *);

  void chInitModule (void);
  void chStatistics (/*(FILE *)*/);
  void chCloseModule (void);

#if defined __cplusplus
}
#endif /* __cplusplus */

#endif /* __HEAPMEM_H__ */
