/* $Id: nstream_file.c,v 6.4 2001/06/23 07:03:05 cher Exp $ */

/* Copyright (C) 1998-2001 Alexander Chernov <cher@ispras.ru> */

/*
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

static char const cvsid[] =
"$Id: nstream_file.c,v 6.4 2001/06/23 07:03:05 cher Exp $";

#include "lconfig.h"
#include <p_config.h>

#include CONF_DEPFILE("reuse_version.h")

#include "reuse/nstream_io.h"
#include "reuse/nstream_private.h"
#include "reuse/xalloc.h"

struct stream_data
{
        struct stream_generic_data x;
        char    *name;  /* name assosiated with this file */
};

static void *v_create();
static int   v_open();
static int   v_fcntl();
static void  v_destroy();

struct stream_vtable stream_file_vtable =
{
        v_create,                       /* create */
        v_open,                         /* open */
        nstream_generic_close,          /* close */
        v_fcntl,                        /* fcntl */
        nstream_generic_read,           /* read */
        nstream_generic_write,          /* write */
        0,                              /* recover */
        v_destroy                       /* destroy */
};

        static void *
v_create(p)
        struct stream_data *p;
{
        if (!p) {
                p = xmalloc(sizeof (struct stream_data));
                p->x.refs = 1;
                p->name = 0;
                p->x.fd   = -1;
        } else {
                p->x.refs++;
        }
        return p;
}

        static void
v_destroy(p)
        struct stream_data *p;
{
        if (!p) return;
        if (p->x.fd != -1) stream_file_vtable.close(p);
        if (!--p->x.refs) {
                xfree(p->name);
                xfree(p);
        }
}

        static int
v_open()
{
        return -1;
}

        static int
v_fcntl()
{
        return -1;
}

/* === Do not add stuff after this line === */
