/* $Id: nstream_generic.c,v 6.5 2001/06/23 07:03:05 cher Exp $ */

/* Copyright (C) 1998-2001 Alexander Chernov <cher@ispras.ru> */

/*
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

static char const cvsid[] =
"$Id: nstream_generic.c,v 6.5 2001/06/23 07:03:05 cher Exp $";

#include "lconfig.h"
#include <p_config.h>

#include CONF_DEPFILE("reuse_version.h")

#include "reuse/nstream_private.h"

#include <unistd.h>
#include <errno.h>

        int
nstream_generic_read(p, d, n)
        struct stream_generic_data      *p;
        void                            *d;
        int                             n;
{
        int                             r;

        if (p->fd == -1) return -1; /* FIXME: ENOTOPEN */
        errno = 0;
        r = read(p->fd, d, n);
        return (r < 0)?-errno:r;
}

        int
nstream_generic_write(p, d, n)
        struct stream_generic_data      *p;
        void                            *d;
        int                             n;
{
        int                             r;

        if (p->fd == -1) return -1; /* FIXME: ENOTOPEN */
        errno = 0;
        r = write(p->fd, d, n);
        return (r < 0)?-errno:r;
}

        int
nstream_generic_close(p)
        struct stream_generic_data      *p;
{
        int                             r;

        if (p->fd == -1) return 0;
        errno = 0;
        r = close(p->fd);
        p->fd = -1;
        return (r < 0)?-errno:r;
}

/* === Do not add stuff after this line === */
