/* $Id: nstream_private.h,v 6.3 2001/06/23 07:03:05 cher Exp $ */

#ifndef __STREAM_PRIVATE_H__
#define __STREAM_PRIVATE_H__

/* Copyright (C) 1998-2001 Alexander Chernov <cher@ispras.ru> */

/*
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 2 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

/* This is private interface for all 
 * media-specific stream implementations
 */

struct stream_vtable
{
        void*   (*create)();    /* create request */
        int     (*open)();      /* open request pointer */
        int     (*close)();     /* close virtual function */
        int     (*fcntl)();     /* fcntl request pointer */
        int     (*read)();      /* read request pointer */
        int     (*write)();     /* write request pointer */
        int     (*recover)();   /* recover request pointer */
        void    (*destroy)();   /* destructor */
};

struct stream_generic_data
{
        int     refs;
        int     fd;
};

extern int nstream_generic_read();
extern int nstream_generic_write();
extern int nstream_generic_close();

#endif /* __STREAM_PRIVATE_H__ */
