/* -*- mode:c -*- */
/* $Id: os_snprintf.c,v 1.1 2002/05/19 11:14:10 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>
#include <p_integral.h>

#include "reuse/number_io.h"

#include <stdio.h>

extern int reuse_vsnprintf(char *, int, char const *, va_list);

int
os_snprintf(char *buf, size_t buflen, char const *format, ...)
{
  int     r;
  va_list args;

  va_start(args, format);
#if CONF_HAS_SNPRINTF - 0 == 1
  r = vsnprintf(buf, buflen, format, args);
#elif CONF_HAS__SNPRINTF - 0 == 1
  r = _vsnprintf(buf, buflen, format, args);
#else
  r = reuse_vsnprintf(buf, buflen, format, args);
#endif /* [_]snprintf feature test */
  va_end(args);
  return r;
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 * End:
 */
