/* -*- mode:c -*- */
/* $Id: os_readint.c,v 1.1 2002/05/19 11:14:10 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>
#include <p_integral.h>

#include "reuse/number_io.h"

#include <errno.h>
#include <stdlib.h>

/**
 * NAME:    os_readint
 * PURPOSE: read int value from the string
 * ARGS:    str - string to read from
 *          val - pointer to the location to store read value
 * RETURN:  <0 - error, 0 - ok
 */
int
os_readint(char const *str, int *val)
{
  char *s;
  int t;

  errno = 0;
  t = strtol(str, &s, 10);
  if (*s != 0) return -1;
  if (errno != 0) return -errno;
  *val = t;
  return 0;
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 * End:
 */
