/* -*- mode:c -*- */
/* $Id: os_readll.c,v 1.1 2002/05/19 11:14:10 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>
#include <p_integral.h>

#include "reuse/number_io.h"

#include <errno.h>

#if defined R_HAS_INT64 && R_HAS_INT64 - 0 == 1
extern rllong_t reuse_strtoll(char const *, char **, int);
#endif /* R_HAS_INT64 */

int
os_readll(char const *str, char **endptr, int base, void *pvval)
{
  rllong_t *pval = (rllong_t*) pvval;
  rllong_t  val;
  int       ecode;
  char     *s;

  errno = 0;
  val = reuse_strtoll(str, &s, base);
  ecode = errno;
  errno = 0;
  if (endptr == (char**) 1 && *s) ecode = 1;
  if (endptr && endptr != (char**) 1) *endptr = s;
  *pval = val;
  return -ecode;
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 * End:
 */
