/* -*- mode:c -*- */
/* $Id: posprintf.c,v 1.2 2002/06/10 07:23:26 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>

#include "reuse/PositionsP.h"

#include <stdlib.h>
#include <assert.h>

extern posstate_t positions_state;
#define S positions_state

void
posPrintf(FILE *f,char *strFormat,tPosition Pos)
{
  char strFormatBuf[32];
  char *pcFormatEnd;
  char *pcFormatPtr;
  
  assert(strFormat != NULL);
  assert(f != NULL);
  if (!S.initialized) posInitModule();
  
  for(;*strFormat != '\0';strFormat++)
    {
      if(*strFormat == '%')
        {
          strFormat++;
          if(*strFormat == '\0')
            {
              putc('%',f);
              break;
            }
          else if(*strFormat == '%')
            {
              putc('%',f);
              continue;
            }
          
          pcFormatPtr = strFormatBuf;
          *pcFormatPtr++ = '%';
          
          for(pcFormatEnd = strFormat;
              *pcFormatEnd != '\0' && *pcFormatEnd != 'l'
                 && *pcFormatEnd != 'c' && *pcFormatEnd != 'f'
                 && *pcFormatEnd != 'g';
               *pcFormatPtr++ = *pcFormatEnd++);

          if(*pcFormatEnd == '\0')
            {
              fputs(strFormat,f);
              break;
            }
          
          switch(*pcFormatEnd)
            {
            case 'l':
              *pcFormatPtr++ = 'u';
              *pcFormatPtr = '\0';
              fprintf(f,strFormatBuf,Pos.Line);
              break;
            case 'c':
              *pcFormatPtr++ = 'u';
              *pcFormatPtr = '\0';
              fprintf(f,strFormatBuf,Pos.Column + 1);
              break;
            case 'f':
              *pcFormatPtr++ = 's';
              *pcFormatPtr = '\0';
              fprintf(f,strFormatBuf,ssString(S.fname_table,Pos.FName));
              break;
            default:
              abort();
            }
          
          strFormat = pcFormatEnd;
        }
      else
        putc(*strFormat,f);
    }
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("FILE" "\\sw+_t" "Bool" "tssDesc" "tPosition" "tssEntry")
 * End:
 */
