/* -*- mode:c -*- */
/* $Id: set_copy.c,v 1.2 2002/06/10 07:21:46 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>
#include <p_integral.h>

#include "reuse/bitset.h"
#include "reuse/logger.h"
#include "reuse/xalloc.h"

#include <string.h>

void
set_copy(bitset_t *pdst, bitset_t const *psrc)
{
  ASSERT(pdst);
  ASSERT(psrc);

  pdst->size = psrc->size;
  pdst->arr_size = psrc->arr_size;
  XCALLOC(pdst->bits, pdst->arr_size);
  memcpy(pdst->bits, psrc->bits, psrc->arr_size * sizeof(pdst->bits[0]));
  pdst->card = psrc->card;
  pdst->first = psrc->first;
  pdst->last = psrc->last;
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 * End:
 */

