/* -*- mode:c -*- */
/* $Id: set_init.c,v 1.2 2002/06/10 07:22:01 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>
#include <p_integral.h>

#include "reuse/bitset.h"
#include "reuse/xalloc.h"
#include "reuse/logger.h"

#include <string.h>

void
set_init(bitset_t *pset, unsigned int size)
{
  ASSERT(pset);
  ASSERT(size > 0);

  XMEMZERO(pset, 1);

  pset->size = size;
  pset->arr_size = (pset->size + BITSET_BPW) >> BITSET_BPS;
  XCALLOC(pset->bits, pset->arr_size);
  pset->card = 0;
  pset->first = -1;
  pset->last = -1;
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 * End:
 */

