/* -*- mode:c -*- */
/* $Id: set_is_empty.c,v 1.1 2002/05/19 16:38:03 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>
#include <p_integral.h>

#include "reuse/bitset.h"
#include "reuse/logger.h"

int
set_is_empty(bitset_t const *pset)
{
  register int i;
  register int *p;

  ASSERT(pset);

  i = pset->arr_size;
  p = pset->bits;
  do {
    if (*p) return 0;
  } while (--i);
  return 1;
}


/*
 * Local variables:
 *  compile-command: "make -C .."
 * End:
 */

