/* -*- mode:c -*- */
/* $Id: set_remove.c,v 1.1 2002/05/19 16:38:03 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>
#include <p_integral.h>

#include "reuse/bitset.h"
#include "reuse/logger.h"

void
set_remove(unsigned int el, bitset_t *pdst)
{
  ASSERT(pdst);
  ASSERT(el < pdst->size);

  pdst->bits[el >> BITSET_BPS] &= ~(((unsigned long) 0x80000000) >> (el & BITSET_BPM));

  pdst->card = -1;
  pdst->first = -2;
  pdst->last = -2;
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 * End:
 */

