/* -*- mode:c -*- */
/* $Id: ssadd.c,v 1.1 2002/05/19 11:15:12 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>

#include "reuse/StringSet.h"

#include <assert.h>
#include <string.h>
#include <stdlib.h>

#define CLUSTER            16

#ifdef REUSE_DEBUG
#define CHECKSSD(ssd) \
assert((ssd) != NULL && (ssd)->Table != NULL && (ssd)->Allocd >= (ssd)->Used)
#define CHECK(ptr)     assert(ptr != NULL)
#define CHECKSS(tss,pssd)  assert(tss < (pssd)->Used)
#else
#define CHECKSSD(s)
#define CHECK(ptr)
#define CHECKSS(tss,pssd)
#endif

  tssEntry
_ssAdd(tssDesc *pssd,char *str)
{
  ruint_t i;
  
  CHECKSSD(pssd);

  if(str == NULL)
    str = "";

  /* look for existing string */
  /* It's VERY BAD algorithm implemented here */

  for(i = 0;i < pssd->Used; i++)
    {
      if(!strcmp(str,pssd->Table[i]))
        break;
    }

  if(i < pssd->Used)
    return i;

  /* add new entry to the table */
  if(pssd->Used >= pssd->Allocd)
    {
      pssd->Table = (char**)
        realloc(pssd->Table,(pssd->Allocd += CLUSTER)*sizeof(char*));
      CHECK(pssd->Table);
    }
  pssd->Table[pssd->Used] = strdup(str);
  CHECK(pssd->Table[pssd->Used]);
  return pssd->Used ++;
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("FILE" "\\sw+_t" "tssDesc" "tssEntry" "tFString" "Bool")
 * End:
 */
