/* -*- mode:c -*- */
/* $Id: ssdget.c,v 1.1 2002/05/19 11:15:12 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>

#include "reuse/StringSet.h"
#include "reuse/FlexString.h"

#include <assert.h>
#include <stdlib.h>

#define CLUSTER            16

#ifdef REUSE_DEBUG
#define CHECKSSD(ssd) \
assert((ssd) != NULL && (ssd)->Table != NULL && (ssd)->Allocd >= (ssd)->Used)
#define CHECK(ptr)     assert(ptr != NULL)
#define CHECKSS(tss,pssd)  assert(tss < (pssd)->Used)
#else
#define CHECKSSD(s)
#define CHECK(ptr)
#define CHECKSS(tss,pssd)
#endif

extern tFString StringSet_fsTemp;

/* NOTE: pssd MUST be initialized */

  void
_ssdGet(tssDesc *pssd,FILE *f)
{
  ruint_t uiUsed;
  int i;

  CHECKSSD(pssd);
  CHECK(f);

  if (pssd->Transl != NULL)
    free(pssd->Transl);

  pssd->Transl = NULL;
  pssd->TranslSize = 0;

  if(fread(&uiUsed,sizeof(uiUsed),1,f) != 1)
    {
      fputs("Read error in _ssdGet()\n",stderr);
      abort();
    }

  assert(uiUsed != 0);
  pssd->TranslSize = uiUsed;
  pssd->Transl = (tssEntry*) malloc(sizeof(tssEntry)*uiUsed);
  CHECK(pssd->Transl);
  pssd->Transl[0] = 0;

  for(i=1;(unsigned int) i<uiUsed;i++)
    {
      fsGet(StringSet_fsTemp,f);
      pssd->Transl[i] = _ssAdd(pssd,fsString(StringSet_fsTemp));
    }
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("FILE" "\\sw+_t" "tssDesc" "tssEntry" "tFString" "Bool")
 * End:
 */
