/* -*- mode: C -*- */
/* $Id: strcasecmp.c,v 1.2 2002/05/18 06:25:21 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>
#include <p_integral.h>
#include CONF_DEPFILE("reuse_version.h")

#include "reuse/str_utils.h"

#include <string.h>
#include <ctype.h>

int
reuse_strcasecmp(char const *s1, char const *s2)
{
#if defined CONF_HAS_STRCASECMP && CONF_HAS_STRCASECMP - 0 == 1
  return strcasecmp(s1, s2);
#else
  register const unsigned char *p1 = (const unsigned char *) s1;
  register const unsigned char *p2 = (const unsigned char *) s2;

  while (*p1 && toupper(*p1) == toupper(*p2)) {
    p1++;
    p2++;
  }
  return toupper(*p1) - toupper(*p2);
#endif
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("\\sw+_t" "FILE")
 * End:
 */
