/* -*- mode: C -*- */
/* $Id: strnlen.c,v 1.1 2002/06/08 08:26:13 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>
#include <p_integral.h>

#if CONF_HAS_STRNLEN - 0 == 1 && defined __linux__ && !defined _GNU_SOURCE
#define _GNU_SOURCE 1
#endif

#include "reuse/str_utils.h"

#include <string.h>

size_t
reuse_strnlen(char const *str, size_t maxlen)
{
#if CONF_HAS_STRNLEN - 0 == 1
  return strnlen(str, maxlen);
#else
  size_t ind = 0;

  while (str[ind] && ind < maxlen) ind++;
  return ind;
#endif /* strnlen is present */
}

/*
 * Local variables:
 *  compile-command: "make -C .."
 *  c-font-lock-extra-types: ("\\sw+_t" "FILE")
 * End:
 */
