/* -*- mode:c -*- */
/* $Id: os_errormsg.c,v 1.1 2002/05/17 19:11:09 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>

#include "reuse/osdeps.h"

#include <stdio.h>
#include <string.h>
#include <errno.h>

static char errbuf[256];

/**
 * NAME:    os_ErrorMsg
 * PURPOSE: get error string of the current error (errno variable)
 * RETURN:  error string for the current error
 */
char *
os_ErrorMsg(void)
{
  char *s = 0;

#if CONF_HAS_STRERROR
  s = strerror(errno);
#elif CONF_HAS_SYS_ERRLIST
  if (errno >= 0 && errno < sys_nerr) s = sys_errlist[errno];
#elif CONF_HAS__SYS_ERRLIST
  if (errno >= 0 && errno < _sys_nerr) s = _sys_errlist[errno];
#endif

  sprintf(errbuf, "%d, %s", errno, s?s:"unknown error");
  return errbuf;
}

/*
 * Local variables:
 *  compile-command: "make -C ../.."
 * End:
 */
