/* -*- mode:c -*- */
/* $Id: os_getsignalstring.c,v 1.1 2002/05/17 19:10:57 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>

#include "reuse/osdeps.h"

/* names of signals */
#define SIGNUM 31
static char *signames[SIGNUM] = 
{
  "(unknown signal)",
  "SIGHUP",     "SIGINT",    "SIGQUIT",   "SIGILL",
  "SIGTRAP",    "SIGABRT",   "SIGBUS",    "SIGFPE",
  "SIGKILL",    "SIGUSR1",   "SIGSEGV",   "SIGUSR2",
  "SIGPIPE",    "SIGALRM",   "SIGTERM",   "SIGCHLD",
  "SIGCONT",    "SIGSTOP",   "SIGTSTP",   "SIGTTIN",
  "SIGTTOU",    "SIGURG",    "SIGXCPU",   "SIGXFSZ",
  "SIGVTALRM",  "SIGPROF",   "SIGWINCH",  "SIGIO",
  "SIGPWR"
};

/**
 * NAME:    os_GetSignalString
 * PURPOSE: get the signal name
 * ARGS:    s - signal number
 * RETURN:  string with the signal name
 */
  char *
os_GetSignalString(int s)
{
  if (s <= 0 || s >= SIGNUM)
    return signames[0];
  return signames[s];
}

/*
 * Local variables:
 *  compile-command: "make -C ../.."
 * End:
 */
