/* -*- mode:c -*- */
/* $Id: os_getsignalstring.c,v 1.3 2002/06/09 06:55:07 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>

#include "reuse/osdeps.h"
#include "reuse/format_io.h"

/**
 * NAME:    os_GetSignalString
 * PURPOSE: get the signal name
 * ARGS:    s - signal number
 * RETURN:  string with the signal name
 */
char *
os_GetSignalString(int s)
{
  static char buf[64];

  switch (s) {
  case 5:
    return "Access violation";
  case 256:
    return "Software abort";
  }
  os_snprintf(buf, sizeof(buf), "Signal %d", s);
  return buf;
}

/*
 * Local variables:
 *  compile-command: "make -C ../.."
 * End:
 */
