/* -*- mode:c -*- */
/* $Id: os_nodename.c,v 1.2 2002/05/18 07:37:05 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 */

#include "lconfig.h"
#include <p_config.h>

#include "reuse/osdeps.h"

#include <windows.h>

/**
 * NAME:    os_NodeName
 * PURPOSE: get the host name
 * RETURN:  hostname - string in the static location
 */
static char nodename_buf[MAX_COMPUTERNAME_LENGTH + 16];
char *
os_NodeName(void)
{
  DWORD len = MAX_COMPUTERNAME_LENGTH + 10;

  GetComputerName(nodename_buf, &len);
  nodename_buf[MAX_COMPUTERNAME_LENGTH + 10] = 0;
  return nodename_buf;
}

/*
 * Local variables:
 *  compile-command: "make -C ../.."
 *  c-font-lock-extra-types: ("HANDLE" "FILE" "\\sw+_t" "DWORD" "va_list" "WIN32_FIND_DATA")
 * End:
 */
