/* $Id: test5.c,v 1.2 2002/01/24 08:56:55 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#include <reuse/number_io.h>

#include <stdio.h>
#include <math.h>

void
read_float(char const *str, float ev)
{
  char *eptr = (char *) 1;
  int  ret;
  float val = 0.10101010;
  char ptrdstr[32];

  ret = reuse_readhf(str, &eptr, &val);
  if ((unsigned long) eptr < 100) {
    sprintf(ptrdstr, "<%lu>", (unsigned long) eptr);
  } else {
    sprintf(ptrdstr, "%d", eptr - str);
  }
  printf("<%s>(%g)->%g,%d,%s\n", str, ev, val, ret, ptrdstr);
}

int main(void)
{
  read_float("0x0p+0", 0.0f);
  read_float("0x1p+0", 1.0f);
  read_float("0x1p+1", 2.0f);
  read_float("0x1.99999ap-4", 0.1f);
  read_float("0x1.78c2ap+76", 1.112e+23f);
  read_float("-0x1p+0", -1.0f);
  read_float("-0x1p+1", -2.0f);
  read_float("-0x1.78c2ap+76", -1.112e+23f);
  read_float("-0x1.3482931p+312", (float) (-1.0/0));
  read_float("0x1.32ffe32p+322", (float) (1.0/0));
  read_float("0x1.333p-232", (float) 1e-200);
  read_float("-0x1.333p-232", (float) -1e-200);
  read_float("0x1.77777777777p-5", 0.0458333);
  read_float("inf", (float) (1.0/0));
  read_float("-inf", (float) (-1.0/0));
  read_float("nan", (float) 0.0/0);
  /* various cases of denormalized numbers */
  read_float("0x1fp0", 31.0f);
  read_float("0xffp-1", 127.5f);
  read_float("0x41p1", 130.0f);
  read_float("0x000001fp0", 31.0f);
  read_float("0x00020.8p1", 65.0f);
  read_float("0x0.1p0", 1.0/16);
  read_float("0x0.2p0", 2.0/16);
  read_float("0x0.5p0", 5.0/16);
  read_float("0x0.ap0", 10.0/16);
  read_float("0x0.05p0", 5.0/256);
  read_float("0x0.000000000000000000000000000000001p0", 0.0f);
  return 0;
}

/*
 * Local variables:
 *  compile-command: "gcc -s -O2 -I.. -I~/c-sema/include/ix86-linux test5.c -L../.obj-ix86-linux -Wall -o test5 -lreuse -lm"
 * End:
 */
