/* $Id: test7.c,v 1.2 2002/01/24 08:56:55 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#include <reuse/number_io.h>

#include <stdio.h>
#include <math.h>

void
read_long_double(char const *str, long double ev)
{
  char *eptr = (char *) 1;
  int  ret;
  long double val= 0.10101010101010101010101010101010101010101;
  char ptrdstr[32];

  ret = reuse_readhld(str, &eptr, &val);
  if ((unsigned long) eptr < 100) {
    sprintf(ptrdstr, "<%lu>", (unsigned long) eptr);
  } else {
    sprintf(ptrdstr, "%d", eptr - str);
  }
  printf("<%s>(%Lg)->%Lg,%d,%s\n", str, ev, val, ret, ptrdstr);
}

int main(void)
{
  read_long_double("0x0p+0", 0.0L);
  read_long_double("0x8p-3", 1.0L);
  read_long_double("0x8p-2", 2.0L);
  read_long_double("0xc.ccccccccccccccdp-7", 0.1L);
  read_long_double("0xb.c615008a9326c23p+73", 1.112e+23L);
  read_long_double("-0x8p-3", -1.0L);
  read_long_double("-0x8p-2", -2.0L);
  read_long_double("-0xb.c615008a9326c23p+73", -1.112e+23L);
  read_long_double("-0x1.3482931p+43212", -1.0L/0);
  read_long_double("0x1.32ffe32p+43232", 1.0L/0);
  read_long_double("0x1.333p-22332", 1e-22200L);
  read_long_double("-0x1.333p-22332", -1e-22200L);
  read_long_double("0x1.7777777777777777777777777777777p-5", 0.0458333L);
  read_long_double("inf", 1.0L/0);
  read_long_double("-inf", -1.0L/0);
  read_long_double("nan", 0.0L/0);
  /* various cases of denormalized numbers */
  read_long_double("0x1fp0", 31.0L);
  read_long_double("0xffp-1", 127.5L);
  read_long_double("0x41p1", 130.0L);
  read_long_double("0x000001fp0", 31.0L);
  read_long_double("0x00020.8p1", 65.0L);
  read_long_double("0x0.1p0", 1.0L/16);
  read_long_double("0x0.2p0", 2.0L/16);
  read_long_double("0x0.5p0", 5.0L/16);
  read_long_double("0x0.ap0", 10.0L/16);
  read_long_double("0x0.05p0", 5.0L/256);
  read_long_double("0x0.00000000000000000000000000000000000000000000001p-100",
              1.0/(powl(16,47)*powl(2,100)));
  read_long_double("0x0.00000000000000000000000000000000000000000000001p-900",
                   0.0L);
  read_long_double("0x0.001p-900", 0.0L);
  return 0;
}

/*
 * Local variables:
 *  compile-command: "gcc -O2 -s -I.. -I~/c-sema/include/ix86-linux test7.c -L../.obj-ix86-linux -Wall -o test7 -lreuse -lm"
 * End:
 */
