/* $Id: test8.c,v 1.1 2002/01/24 08:58:41 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#include <reuse/number_io.h>

#include <stdio.h>
#include <math.h>
#include <errno.h>

void
read_long_double(char const *str, long double ev)
{
  char *eptr = (char *) 1;
  long double val;
  char const *ecode = "";
  char ptrdstr[64];

  errno = 0;
  val = reuse_strtold(str, &eptr);
  if (errno == ERANGE) ecode = " (ERANGE)";
  else if (errno) ecode = " (errno != 0)";

  if ((unsigned long) eptr < 100) {
    sprintf(ptrdstr, "<%lu>", (unsigned long) eptr);
  } else {
    sprintf(ptrdstr, "%d", eptr - str);
  }
  printf("<%s>(%Lg)->%Lg%s, %s\n", str, ev, val, ecode, ptrdstr);
}

int main(void)
{
  read_long_double("0", 0.0L);
  read_long_double("-0", -0.0L);
  read_long_double("1.0", 1.0L);
  read_long_double("2.0", 2.0L);
  read_long_double("0.1", 0.1L);
  read_long_double("1.112e+23L", 1.112e+23L);
  read_long_double("-1.0", -1.0L);
  read_long_double("-2.0", -2.0L);
  read_long_double("-1.112e+23", -1.112e+23L);
  read_long_double("133382333333333333333333333333232373733333333.83222222222222222222222222222222222223338383e-244", 133382333333333333333333333333232373733333333.83222222222222222222222222222222222223338383e-244L);
  read_long_double("-1.3482931e+43212", -1.0L/0);
  read_long_double("1.3244432e+43232", 1.0L/0);
  read_long_double("1.333e-22332", 1e-22200L);
  read_long_double("-1.333e-22332", -1e-22200L);
  read_long_double("0.0458333", 0.0458333L);
  read_long_double("inf", 1.0L/0);
  read_long_double("-inf", -1.0L/0);
  read_long_double("nan", 0.0L/0);
  /* various cases of denormalized numbers */
  read_long_double("31.0", 31.0L);
  read_long_double("127.5", 127.5L);
  read_long_double("0000000000000000000000000000000031", 31.0L);
  read_long_double("000000020.8e1", 000000020.8e1L);
  read_long_double("28384723423423428282383838383833939393", 28384723423423428282383838383833939393.0L);
  read_long_double("39393222", 39393222.0L);
  read_long_double("0.00000000000000000000000000000000000000000000001e-100",
                   0.00000000000000000000000000000000000000000000001e-100L);
  return 0;
}

/*
 * Local variables:
 *  compile-command: "gcc -O2 -s -I.. -I~/c-sema/include/ix86-linux test8.c -L../.obj-ix86-linux -Wall -o test8 -lreuse -lm"
 * End:
 */
