/* $Id: test9.c,v 1.1 2002/01/24 08:58:48 cher Exp $ */

/* Copyright (C) 2002 Alexander Chernov <cher@ispras.ru> */

/*
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA
 */

#include <reuse/number_io.h>

#include <stdio.h>
#include <math.h>

void out_long_double(long double v, int forced_len)
{
  char buf[128];
  int  len;

  if (forced_len < 0) forced_len = sizeof(buf);
  memset(buf, 0xFF, sizeof(buf));
  len = reuse_writedld(buf, forced_len, &v);
  if (forced_len > 0) {
    printf("%.25Lg,%d,%d:>>%s<<\n", v, len, forced_len, buf);
  } else {
    printf("%.25Lg,%d,%d:>>%.6s<<\n", v, len, forced_len, buf);
  }
}

int main(void)
{
  out_long_double(0.0L, -1);
  out_long_double(-0.0L, -1);
  out_long_double(1.0L, -1);
  out_long_double(2.0L, -1);
  out_long_double(1.222799L, -1);
  out_long_double(2828372.222L, -1);
  out_long_double(0.1L, -1);
  out_long_double(0.00000001L, -1);
  out_long_double(1.112e23L, -1);
  out_long_double(8.223837292e-29L, -1);
  out_long_double(3.3333333e120, -1);
  out_long_double(2.22282739430227394032937432022227283930482273849332, -1);
  out_long_double(-1.0L, -1);
  out_long_double(-2.0L, -1);
  out_long_double(-0.1L, -1);
  out_long_double(-1.112e23L, -1);
  out_long_double(1e22300L, -1);
  out_long_double(-1e22300L, -1);
  out_long_double(-1e-22100L, -1);
  out_long_double(0.0L/0.0L, -1);

  return 0;
}

/*
 * Local variables:
 *  compile-command: "gcc -O2 -s -Wall -I.. -I~/c-sema/include/ix86-linux test9.c -L../.obj-ix86-linux -Wall -o test9 -lreuse -lm"
 * End:
 */
