#!/bin/sh
# $Id: makedll.sh,v 6.4 2001/06/23 08:02:49 cher Exp $

# Copyright (C) 1999-2001 Alexander Chernov <cher@ispras.ru>

#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

objects=
gendir=./
objdir=./
options=
no_cygwin=
ignore_prefix=
libs=
ldopts=

#export_classes='BCDRT'
export_classes='T'

# Process options
while [ $# -gt 0 ]
do
  case "$1" in
    *.o)
      [ x"${objects}" != x ] && objects="${objects} "
      objects="${objects}${1}"
      ;;
    -l*)
      [ x"${libs}" != x ] && libs="${libs} "
      libs="${libs}${1}"
      ;;
    -L)
      [ x"${ldopts}" != x ] && ldopts="${ldopts} "
      ldopts="${ldopts}${1} ${2}"
      shift
      ;;
    -L*|-s)
      [ x"${ldopts}" != x ] && ldopts="${ldopts} "
      ldopts="${ldopts}${1}"
      ;;
    --gendir)
      gendir="$2"
      shift
      ;;
    --objdir)
      objdir="$2"
      shift;;
    -mno-cygwin)
      no_cygwin="$1"
      ;;
    --impure-prefix)
      impure_prefix="$2"
      shift
      ;;
    --ignore-prefix)
      ignore_prefix="$2"
      shift
      ;;
    -o)
      dest="$2"
      shift
      ;;
    *)
      echo "Warning: option $1 ignored" >&2
      ;;
  esac
  shift
done

if [ x"${ignore_prefix}" != x ]
then
  objects=`echo "${objects}" | sed s="${ignore_prefix}"==g`
fi

destbase=`basename "${dest}" .dll`

basefile="${objdir}${destbase}.base"
deffile="${gendir}${destbase}.def"
expfile="${objdir}${destbase}.exp"
libfile="${objdir}lib${destbase}.a"

initc="${gendir}dllinit.c"
inito="${objdir}dllinit.o"
fixupc="${gendir}dllfixup.c"
fixupo="${objdir}dllfixup.o"

all_obj="${objects} ${inito} ${fixupo}"

impure_name="${impure_prefix}_impure_ptr"

cat > "${initc}" <<EOF
#include <windows.h>
int WINAPI dll_entry(HANDLE h, DWORD w, void *p) { return 1; }
EOF

cat > "${fixupc}" <<EOF
    asm(".section .idata$3\n\t.long 0,0,0,0, 0,0,0,0");
EOF

set -e

gcc ${no_cygwin} "${initc}" -c -o "${inito}"
gcc ${no_cygwin} "${fixupc}" -c -o "${fixupo}"

echo "EXPORTS" > "${deffile}"
#echo "${impure_name}" >> "${deffile}"
nm $all_obj | grep '^........ ['${export_classes}'] _' | sed 's/[^_]*_//' >> "${deffile}"

set -x
gcc ${ldopts} ${no_cygwin} -nostartfiles -Wl,--base-file,${basefile},--dll $all_obj -Wl,-e,_dll_entry@12 -o ${dest} ${libs}
dlltool --as=as --dllname ${dest} --def ${deffile} --base-file ${basefile} --output-exp ${expfile}
gcc ${ldopts} ${no_cygwin} -nostartfiles -Wl,--base-file,${basefile},${expfile},--dll $all_obj -Wl,-e,_dll_entry@12 -o ${dest} ${libs}
dlltool --as=as --dllname ${dest} --def ${deffile} --base-file ${basefile} --output-exp ${expfile}
gcc ${ldopts} ${no_cygwin} -nostartfiles -Wl,--dll,${expfile} ${all_obj} -o ${dest} -Wl,-e,_dll_entry@12 ${libs}
dlltool --as=as --dllname ${dest} --def ${deffile} --output-lib ${libfile}

exit 0
