#!/bin/sh
# $Id: vcld.sh,v 6.5 2001/06/23 08:02:49 cher Exp $

# Copyright (C) 1999-2001 Alexander Chernov <cher@ispras.ru>

#  This program is free software; you can redistribute it and/or
#  modify it under the terms of the GNU Lesser General Public
#  License as published by the Free Software Foundation; either
#  version 2 of the License, or (at your option) any later version.
#
#  This program is distributed in the hope that it will be useful,
#  but WITHOUT ANY WARRANTY; without even the implied warranty of
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#  Lesser General Public License for more details.
#
#  You should have received a copy of the GNU Lesser General Public
#  License along with this library; if not, write to the Free Software
#  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA

if [ x"${L_PRJ_HOME}" = x ]
then
  echo "${0}: L_PRJ_HOME is not set" >&2
  exit 1
fi
if [ x"${L_PRJ_CONFIG}" = x ]
then
  echo "${0}: L_PRJ_CONFIG is not set" >&2
  exit 1
fi

config_file="${L_PRJ_HOME}/etc/.cfg-${L_PRJ_CONFIG}/compile.sh"
if [ -f "${config_file}" ]
then
  . "${config_file}"
else
  echo "${0}: cannot find configuration file" >&2
  exit 1
fi

libpath=
linkopts="/machine:I386 /subsystem:console"
libs=
args=

for i
do
  case "$i" in
    -L*)
      x=`echo "$i" | ${SED} s/^-L//`
      x=`cygpath -w "${x}"`
#      [ x"${libpath}" != x ] && libpath="${libpath};"
#      libpath="${libpath}${x}"
      [ x"${linkopts}" != x ] && linkopts="${linkopts} "
      linkopts=${linkopts}"/libpath:${x}"
     ;;
    -g)
      [ x"${linkopts}" != x ] && linkopts="${linkopts} "
      linkopts=${linkopts}/debug
      ;;
    -l*)
      x=`echo "$i" | ${SED} s/^-l//`
      [ x"${libs}" != x ] && libs="${libs} "
      libs="${libs}${x}.lib"
      ;;
    *)
      [ x"${args}" != x ] && args="${args} "
      args="${args}$i"
      ;;
  esac
done

[ x"${libpath}" != x ] && libpath="/libpath:${libpath}"

set -x
exec ${CXX} ${args} ${libs} /link ${linkopts} ${libpath}
